/*
 * Copyright (c) 1996 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 * 	This product includes software developed by the MASH Research
 * 	Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * @(#) $Header: /cs/research/mice/starship/src/local/CVS_repository/vic/codec/pvh.h,v 1.1 1999/11/05 11:43:27 piers Exp $
 */

#ifndef mash_pvh_h
#define mash_pvh_h

#define NCOMP 3
#define COMP_LUM_DCT	0
#define COMP_LUM_SBC	1
#define COMP_CHM	2

/*
 * number of bits allocated to a given layer number
 */
struct pvh_refinement {
	int channel;		/* channel number that layer appears on */
	int nr;			/* number of refinement bits */
};

struct spatial_hierarchy {
	int base_channel;	/* channel that base layer appears on */
	int bq;			/* base layer quantizer */
	int n;			/* number of refinement layers present */
	pvh_refinement ref[NLAYER];
};

/*XXX pack this according to spec*/
struct pvhhdr {
	u_int8_t version;
	u_int8_t width;
	u_int8_t height;
	u_int8_t ebit;
	u_int8_t base;
	u_int16_t sblk;
	u_int16_t eblk;
	/* resumption pointers */
};

#endif
